# 01_demonstrate_features_of_strings.py

def main():
    print('\nStrings hold homogenous data -- characters...')
    homogenous_string = 'This string is made up of many characters.'
    print(homogenous_string)

    print('\nStrings are immutable...')
    my_string_variable = 'Strings might appear to change. '
    print(my_string_variable)
    print(id(my_string_variable))
    my_string_variable += 'But, they really are immutable.'
    print(my_string_variable)
    print(id(my_string_variable))

    print('\nStrings are unpackable...')
    unpackable_string = 'AEIOU'
    print(unpackable_string)
    first, second, third, fourth, fifth = unpackable_string
    print(first, second, third, fourth, fifth)

    print('\nStrings can be created easily from other sequence types...')
    print('\nFrom a list of strings...')
    letters_list = ['Q', 'R', 'S', 'T']
    print(letters_list)
    letters_string = ''.join(letters_list)
    print(letters_string)

    print('\nFrom a tuple of strings...')
    letters_tuple = ('L', 'M', 'N', 'O', 'P')
    print(letters_tuple)
    letters_string = ''.join(letters_tuple)
    print(letters_string)

    print('\nFrom a file...')
    my_file = open('wet_birds.txt', 'r', encoding='utf-8')
    big_string_blob = my_file.read()
    print(big_string_blob)


main()
