# 02_demonstrate_features_of_tuples.py

def main():
    print('\nTuples can hold diverse types of objects...')
    diverse_tuple = ('stringy', 1, 25.00, True)
    print(diverse_tuple)

    print('\nTuples are immutable...')
    my_tuple_variable = ('original', 'tuple')
    print(my_tuple_variable)
    print(id(my_tuple_variable))
    my_tuple_variable += ('with', 'added', 'values')
    print(my_tuple_variable)
    print(id(my_tuple_variable))

    print('\nTuples are joinable..')
    joinable_tuple = ('these', 'words', 'form', 'a', 'full', 'sentence')
    print(joinable_tuple)
    sentence = ' '.join(joinable_tuple)
    proper_sentence = sentence.capitalize() + '.'
    print(proper_sentence)

    print('\nTuples are iterable...')
    iterable_tuple = ('process', 'with', 'FOR-IN', 'construct')
    print(iterable_tuple)
    for word in iterable_tuple:
        print(word)

    print('\nTuples are unpackable...')
    unpackable_tuple = ('this', 'tuple', 'is', 'easily', 'unpacked')
    print(unpackable_tuple)
    first, second, third, fourth, fifth = unpackable_tuple
    print(first, second, third, fourth, fifth)

    print('\nTuples can be created easily from other sequence types...')
    print('\nFrom a string...')
    some_long_string = 'This is a very long string'
    print(some_long_string)
    some_long_tuple = tuple(some_long_string)
    print(some_long_tuple)

    print('\nFrom a list...')
    some_list = ['these', 'words', 'make', 'up', 'a', 'sequence']
    print(some_list)
    some_long_tuple = tuple(some_list)
    print(some_long_tuple)

    print('\nFrom a file...')
    my_file = open('wet_birds.txt', 'r', encoding='utf-8')
    my_tuple = tuple(my_file)
    print(my_tuple)


main()
