# 03_demonstrate_features_of_lists.py

def main():
    print('\nLists can hold diverse types of objects...')
    diverse_list = ['stringy', 1, 25.00, True]
    print(diverse_list)

    print('\nLists are mutable...')
    mutable_list = ['lists', 'are', 'mutable']
    print(mutable_list)
    mutable_list.append('gadgets')
    print(mutable_list)
    mutable_list.remove('gadgets')
    print(mutable_list)
    mutable_list.append('containers')
    print(mutable_list)
    mutable_list.insert(2, 'very')
    print(mutable_list)

    print('\nLists are joinable..')
    joinable_list = ['these', 'words', 'form', 'a', 'full', 'sentence']
    print(joinable_list)
    sentence = ' '.join(joinable_list)
    proper_sentence = sentence.capitalize() + '.'
    print(proper_sentence)

    print('\nLists are iterable...')
    iterable_list = ['process', 'with', 'FOR-IN', 'construct']
    print(iterable_list)
    for word in iterable_list:
        print(word)

    print('\nLists are unpackable...')
    unpackable_list = ['this', 'list', 'is', 'easily', 'unpacked']
    print(unpackable_list)
    first, second, third, fourth, fifth = unpackable_list
    print(first, second, third, fourth, fifth)

    print('\nList can be created easily from other sequence types...')
    print('\nFrom a string...')
    some_long_string = 'This is a very long string'
    print(some_long_string)
    some_long_list = list(some_long_string)
    print(some_long_list)

    print('\nFrom a tuple...')
    some_tuple = ('these', 'words', 'make', 'up', 'a', 'sequence')
    print(some_tuple)
    some_list = list(some_tuple)
    print(some_list)

    print('\nDirectly from a file...')
    my_file = open('wet_birds.txt', 'r', encoding='utf-8')
    my_list = list(my_file)
    print(my_list)

    print('\nIndirectly from a file...')
    my_file = open('wet_birds.txt', 'r', encoding='utf-8')
    my_list = my_file.readlines()
    print(my_list)


main()
