# 04_demonstrate_features_of_files.py

def main():
    print('\nFiles hold homogenous data -- strings...')
    my_file = open('wet_birds.txt', 'r', encoding='utf-8')
    big_string_blob = my_file.read()
    my_file.close()
    print(type(big_string_blob))
    print(big_string_blob)

    print('\nFiles are mutable...')
    print('\nOriginal file contents...')
    my_file = open('wet_birds.txt', 'r', encoding='utf-8')
    for line in my_file:
        print(line)
    my_file.close()
    my_file = open('wet_birds.txt', 'a', encoding='utf-8')
    print('I can add a line to the file whenever I want.', file=my_file)
    my_file.close()
    print('\nModified file contents...')
    my_file = open('wet_birds.txt', 'r', encoding='utf-8')
    for line in my_file:
        print(line)
    my_file.close()

    print('\nFiles are iterable...')
    my_file = open('wet_birds.txt', 'r', encoding='utf-8')
    for line in my_file:
        print(line)
    my_file.close()

    print('\nFiles can be easily turned into lists...')
    my_file = open('wet_birds.txt', 'r', encoding='utf-8')
    now_list = list(my_file)
    print(now_list)

    print('\nFiles can be easily turned into tuples...')
    my_file = open('wet_birds.txt', 'r', encoding='utf-8')
    now_tuple = tuple(my_file)
    print(now_tuple)

    print('\nFiles can be easily turned into strings...')
    my_file = open('wet_birds.txt', 'r', encoding='utf-8')
    now_string = my_file.read()
    print(now_string)


main()
